Subject: Re: [PATCH] TCPCT+1: initial SYN exchange with SYNACK data

From: William Allen Simpson <[email-masked]>
Date: Mon, 05 Oct 2009 03:45:51 -0400

As I'm new to Linux kernel development, this was based entirely on code
previously reviewed (by Miller), as that seemed a good path for me to learn
proper coding and style.

Now that I'm trying to grok Linux locking functions for the next patch, I've
noticed that setsockopt code uses lock_sock(), but getsockopt doesn't.  In a
preemptive kernel, or with SMP, isn't there a possibility that these socket
values could be modified or destroyed at the same time?

I'm especially concerned here, as there are kref blocks, and they could be
left pointing into the weeds?